<template>
  <SinglePane class="card-wrapper">
    <div class="resource-page">
      <div class="resource-page__head-wrapper">
        <div class="resource-page__head">
          <i
            class="icon chevron-left resource-page__back-button"
            @click="onStepBack"
          />

          <div class="resource-page__heading">
            <span class="resource-page__title">
              {{ resourceTitle || '—' }}
            </span>

            <span class="resource-page__subtitle">
              {{ ownerTitle || '—' }}<template v-if="ownerInn">, ИНН {{ ownerInn }}</template>
            </span>
          </div>

          <ObMenuDropdown
            v-if="role === 'moderator'"
            :items="menu"
            class="resource-page-menu"
          />
        </div>

        <div class="resource-tabs-container">
          <ObTabs
            ref="resource-tabs"
            :items="tabs"
            :no-border="true"
            @on-change-tab="onChangeTab"
          />
        </div>
      </div>

      <basic-data
        v-show="selectedTab.name === 'basicData'"
        :groups="groups"
        :attaches="attaches"
        :resourceRisk="resourceRisk"
        :isTemporaryRisk="isTemporaryRisk"
        :pending="pending"
        @refresh="onRefresh"
      />

      <documents
        v-show="selectedTab.name === 'documents'"
        :method="getDocumentsMethod()"
        :with-editing="true"
        type="resources"
      />
    </div>

    <Chat/>

    <deleteWarning
      ref="delete-warning"
      :error-message="deleteWarningErrorMessage"
      :is-organization="false"
      @submit="deleteResource"
    >
      {{ resourceTitle }}
      <template v-if="regNum"><br> Госномер {{ regNum }}</template>
    </deleteWarning>
  </SinglePane>
</template>

<script>
  import api from '@/api'

  import BasicData from './tabs/basicData'
  import Documents from '../../components/SB/documents'
  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
  import ObTabs from "common-components/src/obComponents/obTabs/index"
  import Chat from '@/components/chat'
  import { mapGetters } from 'vuex'
  import deleteWarning from '../../components/SB/delete-warning'

  export default {
    name: 'ResourceDetail',
    components: {
      SinglePane,
      Chat,
      ObMenuDropdown,
      ObTabs,
      BasicData,
      Documents,
      deleteWarning
    },
    computed: {
      ...mapGetters({
        role: 'user/role',
        isModerator: "user/isModerator"
      }),
      uuid: ({ $route }) => $route.params.uuid,
      selectedTab: ({ tabs, selectedTabId }) => tabs.find(tab => tab.id === selectedTabId),
      regNum ({ groups }) {
        for (let group of groups) {
          const found = group.fields.find(field => field.code === 'regnum')

          if (found) {
            const value = found.values.find(value => value.isPriority) || found.values[0]

            return value?.data.value
          }
        }

        return null
      }
    },
    data() {
      return {
        pending: false,
        ownerInn: null,
        ownerTitle: null,
        resourceTitle: null,
        menu: [
          {
            title: 'Удалить ресурс',
            className: '-light-raspberry-red',
            icon: 'trash',
            method: this.showDeleteWarning
          }
        ],
        tabs: [
          {
            title: "Основные данные",
            name: "basicData",
            id: 1
          },
          {
            title: "Документы",
            name: "documents",
            id: 2
          }
        ],
        selectedTabId: 1,

        groups: [],
        attaches: [],
        resourceRisk: {},
        isTemporaryRisk: true,
        deleteWarningErrorMessage: null
      };
    },
    methods: {
      async fetch () {
        this.pending = true;

        try {
          const response = await api.resources.getResourceCard(this.uuid);

          this.resourceRisk = response.domains.domains[0].risk || {};
          this.ownerInn = response.ownerInn;
          this.ownerTitle = response.ownerTitle;
          this.isTemporaryRisk = !!response.isTemporaryRisk; // Convert null to boolean

          this.resourceTitle = response.species_title + (response.type_title ? ' – ' + response.type_title : '');
          document.title = this.resourceTitle;

          this.attaches = response.domains.domains[0].links;
          this.groups = response.domains.domains[0].groups;

          this.groups.push({
            requisiteGroupTitle: 'Загруженные файлы',
            fields: this.getAttachFields(),
            'data-attr': 'no-th'
          });

          const additionalFields = [
            {
              title: 'Класс ресурса',
              value: response.class_title
            },
            {
              title: 'Вид ресурса',
              value: response.species_title
            },
            {
              title: 'Страна регистрации',
              value: response.country_title
            }
          ]

          // Adding resource type if resource is not driver and tractor
          if (response.type_title) {
            additionalFields.push({
              title: 'Тип ресурса',
              value: response.type_title
            });
          }

          const additionalGroup = {
            requisiteGroupTitle: 'Регистрационные данные',
            fields: additionalFields.map(({ title, value }) => {
              return {
                title,
                isKeyField: true,
                dataType: 'TEXT',
                values: [{ data: { value } }]
              }
            })
          };

          const { worker_roles } = await api.users.getUserRoles()
          const isAdministrator = worker_roles.find(role => role.isAdministrator)

          let fieldIndex = 1;

          this.groups.unshift(additionalGroup);
          this.groups.forEach(group => {
            this.$set(group, '_isOpen', true)

            group.fields = group.fields.map((field) => {
              const data = {
                ...field,
                index: fieldIndex++,
                valueType: field.dataType,
                editDisable: field.needRiskAssessment || field.isKeyField || field.isAttach || !isAdministrator
              }

              if (field.values?.length) {
                // Added fallback if 'isPriority' is 'false' in every item
                const fieldData = field.values.find(value => value.isPriority) || field.values[0]

                if (data.dataType.startsWith('CHECKLIST')) {
                  data.value = fieldData.data.value || fieldData.data.values
                  data.initialValue = fieldData.data.valuesTitled.values
                }
              }

              if (field.dictionary_code) {
                data.remoteOpts = { method: this.getDictionaryList, arguments: { dictionaryName: field.dictionary_code }}
              }

              if (field.code === 'phone') {
                data.valueType = 'INTEGER'
              }

              return data
            })
          })

        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }

        this.pending = false;
      },
      getDocumentsMethod () {
        return api.resources.getResourceDocuments
      },
      showDeleteWarning () {
        this.deleteWarningErrorMessage = null

        this.$refs['delete-warning'].open()
      },
      async deleteResource () {
        try {
          await api.resources.deleteResource(this.uuid)

          this.$notification({
            type: 'system_notification_success',
            message: 'Ресурс успешно удалён'
          })

          this.onStepBack()
        } catch (e) {
          console.error(e)

          switch (e.code) {
            case 2:
              this.deleteWarningErrorMessage = "Ресурс участвует во вторичных заказах"
              break

            default:
              this.deleteWarningErrorMessage = "Ошибка удаления ресурса"
              break
          }

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка удаления ресурса'
          })
        }
      },
      getAttachFields () {
        return this.attaches.reduce((attaches, item) => {
          attaches.push({
            isAttach: true,
            title: item.docTypeTitle,
            fileName: item.fileName,
            action: () => {
              this.downloadFile(item.fileUuid, item.fileName)
            }
          })

          return attaches
        }, [])
      },
      async getDictionaryList ({ dictionaryName, page, size, query, sort }) {
        try {
          const { data } = await api.taskMonitor.getOptions(dictionaryName, page, size, query, sort)

          if (typeof data[0] === 'undefined' && dictionaryName !== "country") {
            return Object.values(data)[0]
          } else {
            return data
          }
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      },
      async downloadFile (fileUuid, fileName) {
        try {
          const { data } = await api.organisations.getFileByUuid(fileUuid)

          const url = window.URL.createObjectURL(new Blob([data]))
          const link = document.createElement('a')

          link.href = url
          link.setAttribute('download', fileName)
          document.body.appendChild(link)
          link.click()
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      },

      // 👂 Events
      onChangeTab({ id }) {
        this.selectedTabId = id;
      },
      hasHistory () { 
        return window.history.length > 2 
      },
      onStepBack () {
        if (this.hasHistory()) {
          this.$router.go(-1)
        } else {
          this.$router.push({
            path: this.isModerator ? '/sb_resource' : '/resources'
          });
          document.title = 'Ресурсы';
        }
      },
      onRefresh () {
        this.fetch();
      },
    },
    
    created () {
      this.fetch();
    },
  };
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';

  .card-wrapper {
    overflow: hidden; // To clip shadows
  }

  .resource-page {
    &__head-wrapper {
      position: relative;
      z-index: 1; // To showing <ObTabs> border over content

      &::after {
        content: "";
        position: absolute;
        top: 0;
        left: 0;
        z-index: 1; // Over ObFuncPanel elements
        width: 100%;
        height: 100%;
        pointer-events: none;
        box-shadow:
          0 0 2px rgba($blue-700, 0.15),
          0 0 12px rgba($blue-700, 0.04),
          0 4px 10px rgba($blue-700, 0.06);
      }
    }

    &__head {
      display: flex;
      padding: 13px 10px 11px 20px;
      margin-bottom: 11px;
      border-bottom: 1px solid $lavender;
      align-items: center;
    }

    &__back-button {
      font-size: 24px;
      margin-right: 21px;
      color: $color-blue-navy-blue;
      cursor: pointer;
    }

    &__heading {
      display: grid;
    }

    &__title {
      @include font-mixin(24px, 36px, bold, $Grey-900);

      margin-bottom: -6px;
    }

    &__subtitle {
      @include font-mixin(14px, 18px, normal, $color-grey-label);
    }
  }

  .resource-tabs-container {
    padding: 0 20px;
  }

  .resource-page-menu::v-deep {
    margin-left: auto;

    .menu-dropdown-list__item button i {
      color: inherit;

      &::before {
        color: inherit;
      }
    }
  }
</style>
